VERSION 5.00
Begin VB.Form AlignFrm 
   Caption         =   "Align Molecules"
   ClientHeight    =   1905
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   3330
   LinkTopic       =   "Form1"
   ScaleHeight     =   1905
   ScaleWidth      =   3330
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Close 
      Caption         =   "Close"
      Height          =   495
      Left            =   1800
      TabIndex        =   2
      Top             =   1320
      Width           =   1455
   End
   Begin VB.CommandButton doAlign 
      Caption         =   "Align"
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   1320
      Width           =   1575
   End
   Begin VB.Label Label1 
      BorderStyle     =   1  'Fixed Single
      Caption         =   $"AlignFrm.frx":0000
      Height          =   975
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   3135
   End
End
Attribute VB_Name = "AlignFrm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Sub doAlign_Click()
    
    Dim activeDoc As Object
    Set activeDoc = Viewer.ActiveDocument
    
    activeDoc.UpdateData True

   ' Variables and arrays needed by this routine
    Dim x, y, z As Double
    Dim monitors() As String
    Dim monitoredAtoms() As String
    Dim fitAtoms() As String
    Dim molecules() As String
    
    Point3d::Array fitPoints, ontoPoints, points;

    ' Send a command to the viewer which will return the oivs of all distance monitors
    ' (look for objects of type DistanceMonitor with any label)
    Dim result As String
    Dim command As String
    Set command = "GetPropertyValue DistanceMonitor label=" * ": oiv=?"
    Set result = Doc.DoCommand(command)

    ' Gather up the distance monitors, if there are none specified, put up a message,
    ' and return.
    extractOivs result, monitors

    Dim nMonitors As Integer
    Set nMonitors = monitors.Size
    If (nMonitors = 0) Then
        MsgBox ("No Distance Monitors defined for Alignment.")
        GoTo alignExit
    End If
    
    ' Turn off incremental display updates in the Viewer
    Doc.DoCommand ("UpdateView off")

    ' Using the oivs of the monitors, find the atoms being monitored
    For i = 0 To nMonitors
    
        command = "GetPropertyValue DistanceMonitor oiv=" + monitors(i) + ": objects=?"
        result = Doc.DoCommand(command)
        extractOivs result, monitoredAtoms

        ' Now find the molecules the atoms are in
        ' (there should really be some error checking to make sure only two molecules are being fit)
        Dim nFitObjects As Integer
        Set nFitObjects = monitoredAtoms.Size
        For j = 0 To nFitObjects
        
            command = "GetPropertyValue Atom oiv=" + monitoredAtoms(j) + ": Molecule=?"
            result = Doc.DoCommand(command)

            If (molecules.Size = 0) Then
                molecules.push_back (result)
            End If
            If (molecules.Size = 1) Then
                If (result = molecules(0)) Then
                Else
                    molecules.push_back (result)
                End If
            End If
            
        Next j
        
    Next i

    ' Separate all the xyz points to fit into two arrays corresponding to each molecule
    Dim nFitObjects As Integer
    Set nFitObject = monitoredAtoms.Size
    For k = 0 To nFitObjects
    
        command = "GetPropertyValue Atom oiv=" + monitoredAtoms(k) + ": xyz=?"
        result = Doc.DoCommand(command)
        sscanf(result,"%f %f %f", &x, &y, &z);

        If (monitoredAtoms(k).Find(molecules(1))) Then
            ontoPoints.Add (Point3d(x, y, z))
        Else
            fitPoints.Add (Point3d(x, y, z))
        End If

    Next k

    ' Now get ALL the atom points of the second molecule
    command = "GetPropertyValue Molecule oiv=" + molecules(1) + "; Atom label=" * ": xyz=?"
    result = Doc.DoCommand(command)
    extractPoints result, points

    ' Fit 'fitPoints' onto 'ontoPoints' and apply the transformation to 'points'
    RMSBestFit fitPoints, ontoPoints, points

    ' Get the oivs of all the atoms in the second molecule
    command = "GetPropertyValue Molecule oiv=" + molecules(1) + "; Atom label=" * ": oiv=?"
    result = Doc.DoCommand(command)
    extractOivs result, fitAtoms

    ' now update the atom coordinates of the second molecule
    Dim xyzString As String
    Dim nPoints As Integer
    Set nPoints = points.Size

    For l = 0 To nPoints
    
        points(i).GetXYZ(x, y, z)
        xyzString = x + " " + y + " " + z
        command = "SetProperty Atom oiv=" + fitAtoms(i) + ": xyz=" + xyzString
        Doc.DoCommand (command)
        
    Next l
    
    ' Uncomment the following lines of code if you would like to remove the
    ' distance monitors after the alignment operation
    ' doc.DoCommand("UnselectAll")
    ' doc.DoCommand("SetProperty DistanceMonitor label=\"*\":select=true")
    ' doc.DoCommand("Delete")
    
    ' We're done.  Force a redisplay in the Viewer to show the overlay
    Doc.DoCommand ("UpdateView on")

alignExit:
    
End Sub

Private Sub Close_Click()

    AlignFrm.Visible = False
    
End Sub


Private Sub extractOivs (String() result, String() oivs)
    
    while (!result.IsEmpty()) {
        int pos = result.FindOneOf(", ");
        if (pos >= 0) {
            CString oiv = result.Left(pos);
            oivs.push_back(oiv);
            result = result.Mid(pos+1);
        }
        else {
            oivs.push_back(result);
            result.Empty();
        }
    }

    return oivs.size();
End Sub

Private Sub extractPoints (String result, Point3d::Array points)
    
    while (!result.IsEmpty()) {
        float x, y, z;

        int pos = result.FindOneOf(",");
        if (pos >= 0) {
            CString xyzs = result.Left(pos);

            sscanf(xyzs, "%f %f %f", &x, &y, &z);
            points.Add(Point3d(x, y, z));
            result = result.Mid(pos+1);
        }
        else {
            sscanf(result, "%f %f %f", &x, &y, &z);
            points.Add(Point3d(x, y, z));
            result.Empty();
        }
    }

    return points.GetSize();
End Sub

