// MyToolsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "cderr.h"	// to support FNERR_BUFFERTOOSMALL
#include "MyTools.h"
#include "MyToolsDlg.h"
#include "Viewer.h"
#include "ViewerCommand.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyToolsDlg dialog

CMyToolsDlg::CMyToolsDlg(CWnd* pParent /*=NULL*/)
:	CDialog(CMyToolsDlg::IDD, pParent),
	m_pViewer(NULL)
{
	CoInitialize(NULL);

	//{{AFX_DATA_INIT(CMyToolsDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

CMyToolsDlg::~CMyToolsDlg()
{
	// delete the interface
	delete m_pViewer;
}

void CMyToolsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMyToolsDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMyToolsDlg, CDialog)
	//{{AFX_MSG_MAP(CMyToolsDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_STARTVIEWER, OnStartviewer)
	ON_BN_CLICKED(IDC_OPENFILE, OnOpenfile)
	ON_BN_CLICKED(IDC_FITTOVIEW, OnFittoview)
	ON_BN_CLICKED(IDC_ADDHYDROGENS, OnAddhydrogens)
	ON_BN_CLICKED(IDC_REMOVEHYDROGENS, OnRemovehydrogens)
	ON_BN_CLICKED(IDC_LINES, OnLines)
	ON_BN_CLICKED(IDC_STICK, OnStick)
	ON_BN_CLICKED(IDC_BALLNSTICK, OnBallnstick)
	ON_BN_CLICKED(IDC_CPK, OnCpk)
	ON_BN_CLICKED(IDC_SURFACE, OnSurface)
	ON_BN_CLICKED(IDC_SPIN, OnSpin)
	ON_BN_CLICKED(IDC_CLEAN, OnClean)
	ON_BN_CLICKED(IDC_ROTATEX, OnRotatex)
	ON_BN_CLICKED(IDC_TREEVIEW, OnTreeview)
	ON_BN_CLICKED(IDC_DATATABLE, OnDatatable)
	ON_BN_CLICKED(IDC_TOOLBARSOFF, OnToolbarsoff)
	ON_BN_CLICKED(IDC_TOOLBARSON, OnToolbarson)
	ON_BN_CLICKED(IDC_TILEHORIZONTAL, OnTilehorizontal)
	ON_BN_CLICKED(IDC_TILEVERTICAL, OnTilevertical)
	ON_BN_CLICKED(IDC_CASCADE, OnCascade)
	ON_BN_CLICKED(IDC_COMMAND, OnCommand)
	ON_BN_CLICKED(IDC_SELECTALL, OnSelectall)
	ON_BN_CLICKED(IDC_COUNTATOMS, OnCountatoms)
	ON_BN_CLICKED(IDC_ALIGN, OnAlign)
	ON_BN_CLICKED(IDC_CLOSEVIEWER, OnCloseviewer)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyToolsDlg message handlers

BOOL CMyToolsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMyToolsDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMyToolsDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMyToolsDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMyToolsDlg::OnStartviewer() 
{
	// Initialize the interface
	m_pViewer = new IViewer;
	m_pViewer->CreateDispatch("WebLabViewerPro.Application");
	m_pViewer->SetVisible(TRUE);

	// MSI:  These lines attempt to get an active document from the Viewer.
	// If the Viewer was already running, there is probably an active document.
	// If no active document exists, create a new document in the Viewer.
	IDispatch* pActiveDoc = m_pViewer->GetActiveDocument();
	
	if (pActiveDoc == NULL) {
		// No active document available, make a new document...
		IDispatch* pDoc = m_pViewer->New("My_New_Document");
	}
}

void CMyToolsDlg::OnOpenfile() 
{
	if (!CheckViewer()) return;

	CString fileTypes;
	fileTypes = 
		"Molecule Files |*.msv;*.msl;*.pdb;*.ent;*.mol;*.mdl;*.sd;*.sdf;*.car;*.csd;*.msf;*.mol2;*.msi;*.cpd;*.chm;*.cif;*.xyz;*.skc;*.grd;*.wvs;*.wvc;*.log;*.txt|Viewer (*.msv) |*.msv|Brookhaven PDB Files (*.pdb,*.ent) |*.pdb;*.ent|MDL MOL Files (*.mol,*.sdf,*.sd,*.mdl) |*.mol;*.sdf;*.sd;*.mdl|InsightII CAR Files (*.car) |*.car|Cambridge Crystallographic (*.csd,*.fdat,*.dat) |*.csd;*.fdat;*.dat|Quanta Files (*.msf) |*.msf|Sybyl MOL2 files (*.mol2) |*.mol2|Cerius2 files (*.msi) |*.msi|Catalyst Files (*.cpd) |*.cpd|Catalyst Query Files (*.chm) |*.chm|Crystallographic Information files (*.cif) |*.cif|XYZ Coordinate (*.xyz) |*.xyz|MDL Sketch (*.skc)|*.skc|InsightII Grid files (*.grd) |*.grd|Viewer Script Files (*.wbc,*.log) |*.wvc;*.log|All Files (*.*) |*.*|";

	CFileDialog dlg(TRUE, NULL, NULL, 
		OFN_HIDEREADONLY | OFN_FILEMUSTEXIST | OFN_ALLOWMULTISELECT,
		fileTypes);

	// Do the deed...
	dlg.m_ofn.nFilterIndex = 1;
	dlg.m_ofn.lpstrInitialDir = "";
	char buffer[2048] = "\0";
	dlg.m_ofn.lpstrFile = buffer;
	dlg.m_ofn.nMaxFile = 2047;

	if (dlg.DoModal() != IDOK)
	{
		DWORD error = CommDlgExtendedError();
		if(error == FNERR_BUFFERTOOSMALL) {	// include cderr.h for this
			AfxMessageBox(IDS_ERR_MULTIFILE_LOAD); // defined in resource.h
		}
		return;
	}

	CString path;
	int nMolsRead = 0;
	for(POSITION pos = dlg.GetStartPosition(); pos != NULL; )
	{
		// Open the file
		path = dlg.GetNextPathName(pos);
		IDocument doc(m_pViewer->New("New Doc"));
		doc.Open(path);

		nMolsRead += 1;
	}

	// Tile them if more than 1 read
	if(nMolsRead > 1)
		m_pViewer->TileVertical();
}

void CMyToolsDlg::OnFittoview() 
{
	DoDocCommand("FitView");
}

void CMyToolsDlg::OnAddhydrogens() 
{
	DoDocCommand("hydrogens add");
}

void CMyToolsDlg::OnRemovehydrogens() 
{
	DoDocCommand("hydrogens delete");
}

void CMyToolsDlg::OnLines() 
{
	DoDocCommand("DisplayStyle atom Line");
}

void CMyToolsDlg::OnStick() 
{
	DoDocCommand("DisplayStyle atom Stick");
}

void CMyToolsDlg::OnBallnstick() 
{
	DoDocCommand("DisplayStyle atom BallAndStick");
}

void CMyToolsDlg::OnCpk() 
{
	DoDocCommand("DisplayStyle atom CPK");
}

void CMyToolsDlg::OnSurface() 
{
	DoDocCommand("Surface");
}

void CMyToolsDlg::OnSpin() 
{
	DoDocCommand("Spin");

	// NOTE: Spinning only occurs when the Viewer is the active application.
	//		 To see the results of this command switch to the Viewer.
	DoDocCommand("popapp"); // just to be sure it comes alive
	//AfxMessageBox("Set the focus to the Viewer to see the molecule spin.");
}

void CMyToolsDlg::OnClean() 
{
	DoDocCommand("Clean");
}

void CMyToolsDlg::OnRotatex() 
{
	DoDocCommand("Rotate X 90");
}

void CMyToolsDlg::OnTreeview() 
{
	if (!CheckViewer()) return;
	IDispatch *pDoc = m_pViewer->GetActiveDocument();
	if (!pDoc) {
		AfxMessageBox("The viewer does not have an active document.", MB_OK);
		return;
	}
	IDocument doc(pDoc);
	ITreeView treeView(doc.GetHierarchyView());
}

void CMyToolsDlg::OnDatatable() 
{
	if (!CheckViewer()) return;
	IDispatch *pDoc = m_pViewer->GetActiveDocument();
	if (!pDoc) {
		AfxMessageBox("The viewer does not have an active document.", MB_OK);
		return;
	}
	IDocument doc(pDoc);
	IGridView gridView(doc.GetTableView());
}

void CMyToolsDlg::OnToolbarsoff() 
{
	if (!CheckViewer()) return;
    m_pViewer->SetDisplayStatusBar(FALSE);
    m_pViewer->SetDisplayToolBar(FALSE);
    m_pViewer->SetDisplayToolPalette(FALSE);
    m_pViewer->SetDisplayBuilderBar(FALSE);
}

void CMyToolsDlg::OnToolbarson() 
{
	if (!CheckViewer()) return;
    m_pViewer->SetDisplayStatusBar(TRUE);
    m_pViewer->SetDisplayToolBar(TRUE);
    m_pViewer->SetDisplayToolPalette(TRUE);
    m_pViewer->SetDisplayBuilderBar(TRUE);
}

void CMyToolsDlg::OnTilehorizontal() 
{
	if (!CheckViewer()) return;
	m_pViewer->TileHorizontal();
}

void CMyToolsDlg::OnTilevertical() 
{
	if (!CheckViewer()) return;
	m_pViewer->TileVertical();	
}

void CMyToolsDlg::OnCascade() 
{
	if (!CheckViewer()) return;
	m_pViewer->Cascade();
}

void CMyToolsDlg::OnCommand() 
{
	if (!CheckViewer()) return;

	CViewerCommand dlg;
	if ( (dlg.DoModal() == IDOK) &&
		 (!dlg.m_command.IsEmpty()) )
	{
		CString commandResults;
		IDispatch *pDoc = m_pViewer->GetActiveDocument();
		IDocument doc(pDoc);
		commandResults = doc.DoCommand(dlg.m_command);
    
		if (commandResults.IsEmpty())
			AfxMessageBox("Command Executed");
		else
			AfxMessageBox(commandResults);
	}
}

void CMyToolsDlg::OnSelectall() 
{
	DoDocCommand("SelectAll");
}

void CMyToolsDlg::OnCountatoms() 
{
	if (!CheckViewer()) return;

	IDispatch *pDoc = m_pViewer->GetActiveDocument();
	if (pDoc)
	{
		CString atomCount;
		IDocument doc(pDoc);
		atomCount = doc.DoCommand("GetProperty Molecule index=0 : Number of Atoms=?");

		if (atomCount.IsEmpty())
			atomCount = "No Molecule object was found!";

		AfxMessageBox(atomCount);
	}
	else
		AfxMessageBox("No Active Document");
}

void CMyToolsDlg::OnAlign() 
{
	// See the Alignment example project
	AfxMessageBox("See the Alignment example project.");
}

void CMyToolsDlg::OnCloseviewer() 
{
	if (!CheckViewer()) return;
	m_pViewer->Quit();
	m_pViewer->ReleaseDispatch();
	m_pViewer = NULL;
}

BOOL CMyToolsDlg::CheckViewer()
{
	if (m_pViewer != NULL)
		return TRUE;

	AfxMessageBox("You need to Start or Connect with the Viewer before using this command!");
	return FALSE;
}

void CMyToolsDlg::DoDocCommand(CString command) 
{
	if (!CheckViewer()) return;
	IDispatch *pDoc = m_pViewer->GetActiveDocument();
	IDocument doc(pDoc);
	doc.DoCommand(command);
}

